var through2 = require('through2');
var anjs = require('anjs');
var fs = require('fs');
var util = require('util');
var mainBowerFiles = require('main-bower-files');
var gutil = require('gulp-util');
module.exports = function (options) {
  options = util._extend({
    isBower: false,
    bowerPaths: {
      //bowerDirectory: bowerPath+'bower_components',
      //bowerJson: bowerPath+'bower.json'
    },
    bowerFilter: /angular-[\s\S]*\.js$/
  },options||{});
  var Anjs = anjs(options);
  options.isBower && bowerFn();
  options.beforeFn && options.beforeFn(Anjs);
  return through2.obj(function(file, enc, cb) {
    if (file.isNull()) {
      return cb(null, file);
    }
    if (file.isStream()) {
      this.emit('error', new gutil.PluginError('gulp-anjs Streaming not supported'));
      return cb();
    }
    var content = file.contents.toString();
    content = Anjs.getContents(content);
    file.contents = new Buffer(content || '');
    this.push(file);
    cb();
  });

  function bowerFn() {
    if (options.bowerPaths && options.bowerPaths.bowerDirectory && fs.existsSync(options.bowerPaths.bowerDirectory)) {
      var arrBowerFiles = mainBowerFiles(options.bowerPaths) || [];
      arrBowerFiles = arrBowerFiles.filter(function (path) {
        return options.bowerFilter.test(path);
      });
      Anjs.filesSetSourceMap(arrBowerFiles);
    }
  }
};
